## kdeconnect 22.12.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

# KDE Release Service Version, managed by release script
set (RELEASE_SERVICE_VERSION_MAJOR "22")
set (RELEASE_SERVICE_VERSION_MINOR "12")
set (RELEASE_SERVICE_VERSION_MICRO "3")
set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")

project(kdeconnect VERSION ${RELEASE_SERVICE_VERSION})

if (SAILFISHOS)
    set(KF5_MIN_VERSION "5.36.0")
    set(QT_MIN_VERSION "5.6.0")
else()
    set(KF5_MIN_VERSION "5.96.0")
    set(QT_MIN_VERSION "5.15.2")
    set(KDE_COMPILERSETTINGS_LEVEL "5.84.0")
endif()
set(KDE_COMPILERSETTINGS_LEVEL "5.82")
set(QCA_MIN_VERSION "2.1.0")

find_package(ECM ${KF5_MIN_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake)

set(CMAKE_C_STANDARD 99)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

include(KDEInstallDirs)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDECMakeSettings)
include(ECMAddTests)
include(ECMSetupVersion)
include(ECMInstallIcons)
include(ECMQtDeclareLoggingCategory)
include(FeatureSummary)
include(GenerateExportHeader)
include(ECMGenerateQmlTypes)
include(KDEClangFormat)
include(KDEGitCommitHooks)
include(ECMQmlModule)
if (NOT SAILFISHOS)
    include(ECMQMLModules)
endif()

include(KDEConnectMacros.cmake)

ecm_setup_version(${RELEASE_SERVICE_VERSION}
    VARIABLE_PREFIX KDECONNECT
    VERSION_HEADER ${CMAKE_CURRENT_BINARY_DIR}/kdeconnect-version.h
)

# Make the version header available by linking against kdeconnectversion
add_library(kdeconnectversion INTERFACE)
target_include_directories(kdeconnectversion INTERFACE ${CMAKE_CURRENT_BINARY_DIR})

if (SAILFISHOS)
    set(KF5_REQUIRED_COMPONENTS I18n CoreAddons Config)
    set(KF5_OPTIONAL_COMPONENTS)

    set(Qca_LIBRARY CONAN_PKG::Qca-qt5)

    add_definitions(-DSAILFISHOS)
else()
    find_package(Qca-qt${QT_MAJOR_VERSION} ${QCA_MIN_VERSION} REQUIRED)
    set(Qca_LIBRARY qca-qt${QT_MAJOR_VERSION})

    set(KF5_REQUIRED_COMPONENTS I18n ConfigWidgets DBusAddons IconThemes Notifications KIO KCMUtils Service Solid Kirigami2 People WindowSystem GuiAddons)
    set(KF5_OPTIONAL_COMPONENTS DocTools Wayland)

    set_package_properties(KF5Kirigami2 PROPERTIES
        DESCRIPTION "QtQuick plugins to build user interfaces based on KDE UX guidelines"
        PURPOSE "Required for KDE Connect's QML-based GUI applications"
        URL "https://www.kde.org/products/kirigami/"
        TYPE RUNTIME
    )

    if(UNIX AND NOT APPLE)
        find_package(KF5Package REQUIRED)
        find_package(KF5PulseAudioQt)
        if (QT_MAJOR_VERSION EQUAL "5")
            find_package(QtWaylandScanner REQUIRED)
        endif()
        find_package(Wayland 1.9 REQUIRED Client)
        find_package(Qt${QT_MAJOR_VERSION} REQUIRED COMPONENTS WaylandClient)
        find_package(PlasmaWaylandProtocols REQUIRED)
    endif()

    find_package(KF5PeopleVCard)
    set_package_properties(KF5PeopleVCard PROPERTIES
        PURPOSE "Read vcards from the file system"
        URL "https://invent.kde.org/pim/kpeoplevcard"
        TYPE RUNTIME
    )

    add_definitions(-DHAVE_KIO)

    #ecm_find_qmlmodule(org.kde.people 1.0) FIXME This results in KPeople code being called which triggers DBus calls which breaks the Windows CI
    ecm_find_qmlmodule(QtQuick.Particles 2.0)

endif()

add_definitions(-DQT_NO_URL_CAST_FROM_STRING -DQT_NO_KEYWORDS -DQT_NO_CAST_FROM_ASCII)

find_package(Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION} REQUIRED COMPONENTS DBus Quick QuickControls2 Network Multimedia)
if (UNIX AND NOT APPLE AND QT_MAJOR_VERSION EQUAL "5")
    find_package(Qt5 ${QT_MIN_VERSION} REQUIRED COMPONENTS X11Extras)
endif()
find_package(KF5 ${KF5_MIN_VERSION} REQUIRED COMPONENTS ${KF5_REQUIRED_COMPONENTS})
if (KF5_OPTIONAL_COMPONENTS)
    find_package(KF5 ${KF5_MIN_VERSION} OPTIONAL_COMPONENTS ${KF5_OPTIONAL_COMPONENTS})
endif()

if (WIN32)
    get_filename_component(WINDOWS_KITS_DIR
        "[HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Windows Kits\\Installed Roots;KitsRoot10]" ABSOLUTE)
    file(READ "${WINDOWS_KITS_DIR}/SDKManifest.xml" SDK_MANIFEST)
    string(REGEX MATCH "PlatformIdentity[^\n]*" PLATFORM_IDENTITY "${SDK_MANIFEST}" )
    string(REGEX MATCH "[0-9][0-9][0-9][0-9][0-9]" WIN_SDK_VERSION "${PLATFORM_IDENTITY}" )
    add_compile_definitions(WIN_SDK_VERSION=${WIN_SDK_VERSION})
endif()

if (NOT ZSH_AUTOCOMPLETE_DIR)
set(ZSH_AUTOCOMPLETE_DIR "${KDE_INSTALL_DATADIR}/zsh/site-functions")
endif()

add_subdirectory(core)
add_subdirectory(plugins)
add_subdirectory(interfaces)

if (NOT SAILFISHOS)

    find_package(KF5QQC2DesktopStyle ${KF5_MIN_VERSION} REQUIRED)
    set_package_properties(KF5QQC2DesktopStyle PROPERTIES TYPE RUNTIME)

    add_subdirectory(icons)
    add_subdirectory(data)
    add_subdirectory(cli)
    add_subdirectory(declarativeplugin)

    add_subdirectory(kcm)
    add_subdirectory(kcmplugin)
    add_subdirectory(daemon)
    add_subdirectory(app)
    add_subdirectory(indicator)
    add_subdirectory(urlhandler)
    add_subdirectory(nautilus-extension)
    add_subdirectory(fileitemactionplugin)
    add_subdirectory(smsapp)
    add_subdirectory(settings)

    if(NOT WIN32 AND NOT APPLE)
        add_subdirectory(kio)
        add_subdirectory(plasmoid)
    endif()
endif()

if(KF5DocTools_FOUND)
    add_subdirectory(doc)
    kdoctools_install(po)
endif()
ki18n_install(po)

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

ecm_qt_install_logging_categories(EXPORT kdeconnect-kde FILE kdeconnect-kde.categories SORT DESTINATION "${KDE_INSTALL_LOGGINGCATEGORIESDIR}")

file(GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES *.cpp *.h)
kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})

kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== app/CMakeLists.txt ===
qt5_add_resources(kdeconnect_SRCS resources.qrc)

qt5_add_resources(kdeconnect_custom_icons_SRCS ${CMAKE_SOURCE_DIR}/icons/custom_icons.qrc)

if (WIN32)
    include(ECMAddAppIcon)
    ecm_add_app_icon(kdeconnect_SRCS ICONS
        ${CMAKE_SOURCE_DIR}/icons/app/sc-apps-kdeconnect.svg
        ${CMAKE_SOURCE_DIR}/icons/app/16-apps-kdeconnect.png
        ${CMAKE_SOURCE_DIR}/icons/app/24-apps-kdeconnect.png
        ${CMAKE_SOURCE_DIR}/icons/app/32-apps-kdeconnect.png
        ${CMAKE_SOURCE_DIR}/icons/app/48-apps-kdeconnect.png
        ${CMAKE_SOURCE_DIR}/icons/app/64-apps-kdeconnect.png
        ${CMAKE_SOURCE_DIR}/icons/app/128-apps-kdeconnect.png
        ${CMAKE_SOURCE_DIR}/icons/app/256-apps-kdeconnect.png
        ${CMAKE_SOURCE_DIR}/icons/app/1024-apps-kdeconnect.png
    )
endif()

add_executable(kdeconnect-app
    main.cpp
    ${kdeconnect_SRCS}
    ${kdeconnect_custom_icons_SRCS}
)
target_link_libraries(kdeconnect-app Qt::Quick Qt::QuickControls2 Qt::Widgets KF5::CoreAddons KF5::I18n KF5::KCMUtils)

install(TARGETS kdeconnect-app ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
install(PROGRAMS org.kde.kdeconnect.app.desktop DESTINATION ${KDE_INSTALL_APPDIR})

=== core/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdeconnect-core\")

set(debug_file_SRCS)

ecm_qt_declare_logging_category(
    debug_file_SRCS HEADER kdeconnect_debug.h
    IDENTIFIER KDECONNECT_CORE CATEGORY_NAME kdeconnect.core
    DEFAULT_SEVERITY Warning
    EXPORT kdeconnect-kde DESCRIPTION "kdeconnect (core)")

set(KDECONNECT_PRIVATE_DBUS_ADDR unix:tmpdir=/tmp)
if(WIN32)
    set(KDECONNECT_PRIVATE_DBUS_ADDR tcp:host=localhost,port=0)
endif()
set(KDECONNECT_PRIVATE_DBUS_NAME DBusKDEConnectOnly)
configure_file(dbushelper.h.in ${CMAKE_CURRENT_BINARY_DIR}/dbushelper.h)

add_subdirectory(backends/lan)
add_subdirectory(backends/loopback)

option(BLUETOOTH_ENABLED "Bluetooth support for kdeconnect" OFF)
if(BLUETOOTH_ENABLED)
    find_package(Qt5 ${QT_MIN_VERSION} REQUIRED COMPONENTS Bluetooth)
    add_subdirectory(backends/bluetooth)
endif()

option(LOOPBACK_ENABLED "Loopback backend enabled" OFF)

set(kdeconnectcore_SRCS
    ${backends_kdeconnect_SRCS}

    backends/linkprovider.cpp
    backends/devicelink.cpp
    backends/pairinghandler.cpp
    backends/devicelinereader.cpp

    kdeconnectplugin.cpp
    kdeconnectpluginconfig.cpp
    pluginloader.cpp

    kdeconnectconfig.cpp
    dbushelper.cpp
    networkpacket.cpp
    filetransferjob.cpp
    compositefiletransferjob.cpp
    daemon.cpp
    device.cpp
    core_debug.cpp
    notificationserverinfo.cpp
    openconfig.cpp
    ${debug_file_SRCS}
)

add_library(kdeconnectcore ${kdeconnectcore_SRCS})

target_include_directories(kdeconnectcore PUBLIC ${PROJECT_SOURCE_DIR})

target_link_libraries(kdeconnectcore
PUBLIC
    Qt${QT_MAJOR_VERSION}::Network
    KF5::CoreAddons
    ${Qca_LIBRARY}
PRIVATE
    Qt${QT_MAJOR_VERSION}::DBus
    KF5::I18n
    KF5::ConfigCore
)

if(${KF5KIO_FOUND})
    target_link_libraries(kdeconnectcore PUBLIC KF5::KIOCore KF5::KIOGui)
endif()

if (BLUETOOTH_ENABLED)
    target_compile_definitions(kdeconnectcore PRIVATE -DKDECONNECT_BLUETOOTH)
    target_link_libraries(kdeconnectcore PRIVATE Qt5::Bluetooth)
endif()

if (LOOPBACK_ENABLED)
    target_compile_definitions(kdeconnectcore PRIVATE -DKDECONNECT_LOOPBACK)
endif()

set_target_properties(kdeconnectcore PROPERTIES
    VERSION ${KDECONNECT_VERSION}
    SOVERSION ${KDECONNECT_VERSION_MAJOR}
)

generate_export_header(kdeconnectcore EXPORT_FILE_NAME kdeconnectcore_export.h BASE_NAME KDEConnectCore)

install(TARGETS kdeconnectcore EXPORT kdeconnectLibraryTargets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} LIBRARY NAMELINK_SKIP)

=== daemon/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN="kdeconnect-kded")

set(debug_file_SRCS)
ecm_qt_declare_logging_category(
    debug_file_SRCS HEADER kdeconnectd_debug.h
    IDENTIFIER KDECONNECT_DAEMON CATEGORY_NAME kdeconnect.daemon
    DEFAULT_SEVERITY Warning
    EXPORT kdeconnect-kde DESCRIPTION "kdeconnect (daemon)")

qt5_add_resources(kdeconnect_custom_icons_SRCS ${CMAKE_SOURCE_DIR}/icons/custom_icons.qrc)

add_executable(kdeconnectd kdeconnectd.cpp ${kdeconnect_custom_icons_SRCS} ${debug_file_SRCS})
target_link_libraries(kdeconnectd
    kdeconnectcore kdeconnectversion
    KF5::KIOWidgets
    KF5::DBusAddons
    KF5::Notifications
    KF5::I18n
    KF5::WindowSystem
    Qt::Widgets)

ecm_mark_nongui_executable(kdeconnectd)

configure_file(org.kde.kdeconnect.daemon.desktop.cmake ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kdeconnect.daemon.desktop)

# Conditionally configure the daemon service according to the target OS
if(WIN32)
    set(SERV_EXEC kdeconnectd)
else()
    set(SERV_EXEC ${KDE_INSTALL_FULL_LIBEXECDIR}/kdeconnectd)
endif()
configure_file(org.kde.kdeconnect.service.in ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kdeconnect.service)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kdeconnect.daemon.desktop DESTINATION ${KDE_INSTALL_AUTOSTARTDIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kdeconnect.daemon.desktop DESTINATION ${KDE_INSTALL_APPDIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.kde.kdeconnect.service DESTINATION ${KDE_INSTALL_DBUSSERVICEDIR})
install(TARGETS kdeconnectd DESTINATION ${KDE_INSTALL_LIBEXECDIR})

=== data/CMakeLists.txt ===
install (FILES "kdeconnect.contract" DESTINATION ${KDE_INSTALL_DATADIR}/contractor/)
install (FILES "kdeconnect-thunar.desktop" DESTINATION ${KDE_INSTALL_DATADIR}/Thunar/sendto/)
install(PROGRAMS org.kde.kdeconnect_open.desktop DESTINATION ${KDE_INSTALL_APPDIR})
install (FILES "kdeconnect-dde.desktop" DESTINATION ${KDE_INSTALL_DATADIR}/deepin/dde-file-manager/oem-menuextensions/)

if(NOT SAILFISHOS)
    install(FILES org.kde.kdeconnect.metainfo.xml DESTINATION ${KDE_INSTALL_METAINFODIR})
endif()

=== fileitemactionplugin/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN="kdeconnect-fileitemaction")

set(debug_file_SRCS)
ecm_qt_declare_logging_category(
    debug_file_SRCS HEADER kdeconnect_fileitemaction_debug.h
    IDENTIFIER KDECONNECT_FILEITEMACTION CATEGORY_NAME kdeconnect.fileitemaction
    DEFAULT_SEVERITY Warning
    EXPORT kdeconnect-kde DESCRIPTION "kdeconnect (fileitemaction)")

add_library(kdeconnectfileitemaction MODULE sendfileitemaction.cpp ${debug_file_SRCS})
target_link_libraries(
    kdeconnectfileitemaction
    KF5::KIOWidgets
    KF5::I18n
    kdeconnectinterfaces
    kdeconnectcore
)
install(TARGETS kdeconnectfileitemaction DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf5/kfileitemaction)

=== kcm/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN="kdeconnect-kcm")


add_library(kcm_kdeconnect MODULE kcm.cpp)

ki18n_wrap_ui(kcm_kdeconnect kcm.ui)
kcoreaddons_desktop_to_json(kcm_kdeconnect "kcm_kdeconnect.desktop")

target_link_libraries(kcm_kdeconnect
    Qt::Core
    Qt::Gui
    KF5::I18n
    KF5::KCMUtils
    kdeconnectinterfaces
    kdeconnectversion
)

install(TARGETS kcm_kdeconnect DESTINATION ${KDE_INSTALL_PLUGINDIR})
install(FILES kcm_kdeconnect.desktop DESTINATION ${KDE_INSTALL_KSERVICESDIR})

=== plugins/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdeconnect-plugins\")

add_subdirectory(ping)
add_subdirectory(connectivity-report)
add_subdirectory(remotecommands)
add_subdirectory(remotecontrol)
add_subdirectory(remotesystemvolume)
add_subdirectory(clipboard)
add_subdirectory(runcommand)


if(NOT WIN32)
    # https://bugs.kde.org/show_bug.cgi?id=444612
    add_subdirectory(battery)
endif()

if(NOT WIN32 AND NOT APPLE)
    add_subdirectory(bigscreen)
endif()

add_subdirectory(presenter)

if(NOT SAILFISHOS)
    if((WIN32 AND MSVC AND (${CMAKE_SYSTEM_VERSION} VERSION_GREATER_EQUAL 10.0.17763.0)) OR NOT WIN32)
        add_subdirectory(mpriscontrol)
    endif()
    add_subdirectory(photo)
    add_subdirectory(mprisremote)
    add_subdirectory(lockdevice)
    add_subdirectory(contacts)
    add_subdirectory(share)
    add_subdirectory(remotekeyboard)
    add_subdirectory(notifications)
    add_subdirectory(findmyphone)
    add_subdirectory(telephony)
    add_subdirectory(mousepad)
    add_subdirectory(sms)
    add_subdirectory(screensaver-inhibit)
    add_subdirectory(virtualmonitor)

    if(NOT WIN32)
        add_subdirectory(sendnotifications)
    endif()

    if(NOT APPLE)
        add_subdirectory(sftp)
    endif()

    if(KF5PulseAudioQt_FOUND OR WIN32)
        add_subdirectory(pausemusic)
    endif()

    if(Qt5Multimedia_FOUND AND (KF5PulseAudioQt_FOUND OR WIN32))
        add_subdirectory(findthisdevice)
    endif()

    if (WIN32 OR APPLE OR KF5PulseAudioQt_FOUND)
        add_subdirectory(systemvolume)
    endif()
endif()


# If we split notifications per plugin, in several notifyrc files, they won't
# appear in the same group in the Notifications KCM
install(FILES kdeconnect.notifyrc DESTINATION ${KDE_INSTALL_KNOTIFYRCDIR})

=== tests/CMakeLists.txt ===
find_package(Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION} REQUIRED COMPONENTS Test)

set(kdeconnect_libraries
    kdeconnectcore
    kdeconnectversion
    KF5::I18n
    Qt::DBus
    Qt::Network
    Qt::Test
)

if(${KF5KIO_FOUND})
    list(APPEND kdeconnect_libraries KF5::KIOWidgets)
endif()

ecm_add_test(pluginloadtest.cpp LINK_LIBRARIES ${kdeconnect_libraries})
ecm_add_test(sendfiletest.cpp LINK_LIBRARIES ${kdeconnect_libraries})
ecm_add_test(testsocketlinereader.cpp TEST_NAME testsocketlinereader LINK_LIBRARIES ${kdeconnect_libraries})

=== urlhandler/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN="kdeconnect-urlhandler")

ki18n_wrap_ui(telhandler_SRCS dialog.ui)

qt5_add_resources(kdeconnect_custom_icons_SRCS ${CMAKE_SOURCE_DIR}/icons/custom_icons.qrc)

add_executable(kdeconnect-handler kdeconnect-handler.cpp ${telhandler_SRCS} ${kdeconnect_custom_icons_SRCS})


target_link_libraries(kdeconnect-handler
    kdeconnectinterfaces
    kdeconnectcore
    kdeconnectversion
    Qt::Widgets
    KF5::CoreAddons
    KF5::DBusAddons
    KF5::I18n
    KF5::KIOCore KF5::KIOFileWidgets KF5::KIOWidgets KF5::KIONTLM
)

install(TARGETS kdeconnect-handler ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
install(PROGRAMS org.kde.kdeconnect.handler.desktop DESTINATION ${KDE_INSTALL_APPDIR} )

=== plugins/contacts/CMakeLists.txt ===
set(debug_file_SRCS)
ecm_qt_declare_logging_category(
    debug_file_SRCS HEADER plugin_contacts_debug.h
    IDENTIFIER KDECONNECT_PLUGIN_CONTACTS CATEGORY_NAME kdeconnect.plugin.contacts
    DEFAULT_SEVERITY Warning
    EXPORT kdeconnect-kde DESCRIPTION "kdeconnect (plugin contacts)")

set(kdeconnect_contacts_SRCS
    contactsplugin.cpp
    ${debug_file_SRCS}
)

kdeconnect_add_plugin(kdeconnect_contacts SOURCES ${kdeconnect_contacts_SRCS})

target_link_libraries(kdeconnect_contacts
    kdeconnectcore
    Qt::DBus
)

=== plugins/mousepad/CMakeLists.txt ===
kdeconnect_add_plugin(kdeconnect_mousepad SOURCES mousepadplugin.cpp abstractremoteinput.cpp)

if(UNIX AND NOT APPLE)

    find_package(LibFakeKey QUIET)
    set_package_properties(LibFakeKey PROPERTIES DESCRIPTION "fake key events"
                        URL "https://www.yoctoproject.org/tools-resources/projects/matchbox"
                        TYPE OPTIONAL
                        PURPOSE "Needed for the remote mousepad plugin"
                        )

    if (QT_MAJOR_VERSION EQUAL "5")
        ecm_add_qtwayland_client_protocol(wayland_SRCS
            PROTOCOL ${PLASMA_WAYLAND_PROTOCOLS_DIR}/fake-input.xml
            BASENAME fake-input
        )
    else()
        qt6_generate_wayland_protocol_client_sources(kdeconnect_mousepad FILES
            ${PLASMA_WAYLAND_PROTOCOLS_DIR}/fake-input.xml)
    endif()

    target_sources(kdeconnect_mousepad PRIVATE ${wayland_SRCS})
    target_link_libraries(kdeconnect_mousepad Wayland::Client Qt::WaylandClient)
    target_sources(kdeconnect_mousepad PUBLIC waylandremoteinput.cpp)
    set(HAVE_WAYLAND TRUE)

    if (LibFakeKey_FOUND)
        if (QT_MAJOR_VERSION EQUAL "5")
            find_package(Qt5 ${QT_MIN_VERSION} REQUIRED COMPONENTS X11Extras)
        endif()
        find_package(XTest REQUIRED)
        find_package(X11 REQUIRED)
        target_include_directories(kdeconnect_mousepad PRIVATE ${XTEST_INCLUDE_DIRS} ${X11_INCLUDE_DIR} ${LibFakeKey_INCLUDE_DIRS})
    endif()
endif()

set(HAVE_WINDOWS ${WIN32})
set(HAVE_X11 ${LibFakeKey_FOUND})
set(HAVE_MACOS ${APPLE})
configure_file(config-mousepad.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-mousepad.h )

target_link_libraries(kdeconnect_mousepad kdeconnectcore Qt::Gui KF5::I18n)

if (HAVE_WINDOWS)
    target_sources(kdeconnect_mousepad PUBLIC windowsremoteinput.cpp)
endif()

if(HAVE_X11)
    target_sources(kdeconnect_mousepad PUBLIC x11remoteinput.cpp)
    if (QT_MAJOR_VERSION EQUAL "5")
        target_link_libraries(kdeconnect_mousepad Qt5::X11Extras)
    endif()
    target_link_libraries(kdeconnect_mousepad ${X11_LIBRARIES} ${XTEST_LIBRARIES} ${LibFakeKey_LIBRARIES})
endif()

if (HAVE_MACOS)
    target_sources(kdeconnect_mousepad PUBLIC macosremoteinput.mm)
    target_link_libraries(kdeconnect_mousepad "-framework CoreGraphics" "-framework ApplicationServices" "-framework Cocoa")
endif()

=== debian/changelog ===
kdeconnect (22.12.3-1) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * New upstream release (22.12.3).
  * Update build-deps and deps with the info from cmake.
  * Drop patch upstream_nautilus-drop-spurious-shebang.patch applied upstream.

 -- Aurélien COUDERC <coucouf@debian.org>  Wed, 01 Mar 2023 11:57:49 +0100

kdeconnect (22.12.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Re-export upstream signing key without extra signatures.
  * Remove inactive Uploaders.
  * Modernize building:
    - add the dh-sequence-kf5 build dependency to use the kf5 addon
      automatically, removing pkg-kde-tools
    - drop all the manually specified addons and buildsystem for dh
  * Backport upstream commit 71803f04d8521199dfa6960f5b84801d9f35d9ee to drop
    the spurious shebang in the nautilus plugin; patch
    upstream_nautilus-drop-spurious-shebang.patch
    - drop the patch fix-python3-interpreter-location, no more needed now
  * Update the patches:
    - kdeconnect-openssh-8.2.patch: refresh

 -- Pino Toscano <pino@debian.org>  Sun, 05 Feb 2023 09:34:13 +0100

=== debian/control ===
Source: kdeconnect
Section: kde
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
Build-Depends: cmake (>= 3.0~),
               debhelper-compat (= 13),
               dh-sequence-kf5,
               extra-cmake-modules (>= 5.96.0~),
               gettext,
               kirigami2-dev (>= 5.96.0~),
               kpeople-vcard,
               libfakekey-dev,
               libkf5configwidgets-dev (>= 5.96.0~),
               libkf5dbusaddons-dev (>= 5.96.0~),
               libkf5doctools-dev (>= 5.96.0~),
               libkf5guiaddons-dev (>= 5.96.0~),
               libkf5i18n-dev (>= 5.96.0~),
               libkf5iconthemes-dev (>= 5.96.0~),
               libkf5kcmutils-dev (>= 5.96.0~),
               libkf5kio-dev (>= 5.96.0~),
               libkf5notifications-dev (>= 5.96.0~),
               libkf5package-dev (>= 5.71.0~),
               libkf5people-dev (>= 5.96.0~),
               libkf5pulseaudioqt-dev,
               libkf5qqc2desktopstyle-dev (>= 5.96.0~),
               libkf5service-dev (>= 5.96.0~),
               libkf5solid-dev (>= 5.96.0~),
               libkf5wayland-dev (>= 4:5.96.0~),
               libkf5windowsystem-dev (>= 5.96.0~),
               libqca-qt5-2-dev (>= 2.1.0~),
               libqt5waylandclient5-dev (>= 5.10.0~),
               libqt5x11extras5-dev (>= 5.15.2~),
               libwayland-dev (>= 1.9~),
               libx11-dev,
               libxtst-dev,
               pkg-config,
               plasma-wayland-protocols,
               qtbase5-dev (>= 5.15.2~),
               qtbase5-private-dev (>= 5.10.0~),
               qtdeclarative5-dev (>= 5.15.2~),
               qtmultimedia5-dev (>= 5.15.2~),
               qtquickcontrols2-5-dev (>= 5.15.2~),
               qtwayland5-dev-tools,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://kdeconnect.kde.org
Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/kdeconnect.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/kdeconnect

Package: kdeconnect
Architecture: any
Depends: fuse3 (>= 3),
         kpeople-vcard,
         libqca-qt5-2-plugins,
         plasma-framework,
         qml-module-org-kde-kirigami2,
         qml-module-org-kde-kquickcontrolsaddons,
         qml-module-org-kde-people,
         qml-module-qt-labs-platform,
         qml-module-qtgraphicaleffects,
         qml-module-qtmultimedia,
         qml-module-qtqml,
         qml-module-qtquick-controls2,
         qml-module-qtquick-dialogs,
         qml-module-qtquick-layouts,
         qml-module-qtquick-particles2,
         qml-module-qtquick-window2,
         qml-module-qtquick2,
         sshfs (>= 3),
         ${misc:Depends},
         ${shlibs:Depends},
Breaks: fuse (<< 3),
Description: connect smartphones to your desktop devices
 Tool to integrate your smartphone, tablet, and desktop devices.
 Remote-control, share files, synchronize notifications, and more!
 At the moment it only supports Android-based mobile devices. Linux desktop
 devices are well-supported, with ports available for other operating systems.

Package: nautilus-kdeconnect
Architecture: all
Depends: kdeconnect, nautilus, python3-nautilus, ${misc:Depends},
Enhances: nautilus,
Breaks: kdeconnect (<< 20.12),
Replaces: kdeconnect (<< 20.12),
Description: KDE Connect integration for Nautilus
 Extension providing integration to send files to KDE Connect compatible
 devices directly from within Nautilus.

## kdeconnect 23.08.0

=== debian/changelog ===
kdeconnect (23.08.0-0ubuntu1) mantic; urgency=medium

  * New upstream release (23.08.0)

 -- Rik Mills <rikmills@kde.org>  Thu, 24 Aug 2023 12:52:41 +0100

kdeconnect (23.07.90-0ubuntu1) mantic; urgency=medium

  * New upstream (beta) release (23.07.80)
  * New upstream (RC) release (23.07.90)

 -- Rik Mills <rikmills@kde.org>  Tue, 15 Aug 2023 02:32:35 +0100

kdeconnect (23.04.3-0ubuntu1) mantic; urgency=medium

  * New upstream release (23.04.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 06 Jul 2023 14:45:12 +0100

kdeconnect (23.04.2-0ubuntu1) mantic; urgency=medium

  [ José Manuel Santamaría Lema ]
  * New upstream release (23.04.1)
  * Update Build-Depends:
    - add modemmanager-qt-dev
    - add wayland-protocols
  * New upstream release (23.04.2)

  [ Rik Mills ]
  * Add runtime depends on qml-module-org-kde-kirigami-addons-labs-
    mobileform, as indicated in cmake output.

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Sat, 10 Jun 2023 11:55:50 +0100

kdeconnect (22.12.3-0ubuntu1) lunar; urgency=medium

  * New upstream release (22.12.3)
  * Drop no longer needed python shebang patch.

 -- Rik Mills <rikmills@kde.org>  Thu, 02 Mar 2023 12:16:00 +0000

kdeconnect (22.12.2-0ubuntu1) lunar; urgency=medium

  * New upstream release (22.12.2)
  * Refresh OpenSSL patch.

 -- Simon Quigley <tsimonq2@kubuntu.org>  Sat, 11 Feb 2023 14:14:36 -0600

kdeconnect (22.12.1-0ubuntu1) lunar; urgency=medium

  * New upstream release (22.12.1)

 -- Rik Mills <rikmills@kde.org>  Thu, 05 Jan 2023 11:13:38 +0000

kdeconnect (22.12.0-2ubuntu1) lunar; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Kubuntu Vcs and maintainer fields.
    - Update upstream signing key.

 -- Rik Mills <rikmills@kde.org>  Wed, 28 Dec 2022 14:00:38 +0000

kdeconnect (22.12.0-0ubuntu1) lunar; urgency=medium

  * New upstream release (22.12.0)

 -- Rik Mills <rikmills@kde.org>  Fri, 09 Dec 2022 19:07:47 +0000

kdeconnect (22.11.90-0ubuntu1) lunar; urgency=medium

  * New upstream (RC) release (22.11.90)

 -- Rik Mills <rikmills@kde.org>  Fri, 25 Nov 2022 16:04:08 +0000

kdeconnect (22.11.80-0ubuntu1) lunar; urgency=medium

  * New upstream (beta) release (22.11.80)
  * Update kdeconnect-openssh-8.2.patch
  * Drop included nautilus-43-compat.patch

 -- Rik Mills <rikmills@kde.org>  Mon, 14 Nov 2022 10:49:33 +0000

kdeconnect (22.08.3-0ubuntu1) lunar; urgency=medium

  * New upstream release (22.08.3)

 -- Rik Mills <rikmills@kde.org>  Mon, 07 Nov 2022 11:07:40 +0000

## kdeconnect 23.08.1

=== debian/changelog ===
kdeconnect (23.08.1-0ubuntu1) mantic; urgency=medium

  * New upstream release (23.08.1)

 -- Rik Mills <rikmills@kde.org>  Thu, 14 Sep 2023 11:57:47 +0100

## kdeconnect 23.08.4

=== debian/changelog ===
kdeconnect (23.08.4-0ubuntu1) noble; urgency=medium

  * New upstream release (23.08.4)

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Wed, 13 Dec 2023 10:13:58 +0000

kdeconnect (23.08.3-0ubuntu1) noble; urgency=medium

  * New upstream release (23.08.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 09 Nov 2023 11:33:27 +0000

kdeconnect (23.08.2-0ubuntu1) noble; urgency=medium

  * New upstream release (23.08.2)

 -- Rik Mills <rikmills@kde.org>  Thu, 26 Oct 2023 12:29:43 +0100

## kdeconnect 23.08.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,9 @@
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.16)
 
 # KDE Release Service Version, managed by release script
-set (RELEASE_SERVICE_VERSION_MAJOR "22")
-set (RELEASE_SERVICE_VERSION_MINOR "12")
-set (RELEASE_SERVICE_VERSION_MICRO "3")
+set (RELEASE_SERVICE_VERSION_MAJOR "23")
+set (RELEASE_SERVICE_VERSION_MINOR "08")
+set (RELEASE_SERVICE_VERSION_MICRO "5")
 set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")
 
 project(kdeconnect VERSION ${RELEASE_SERVICE_VERSION})
@@ -12,7 +12,7 @@
     set(KF5_MIN_VERSION "5.36.0")
     set(QT_MIN_VERSION "5.6.0")
 else()
-    set(KF5_MIN_VERSION "5.96.0")
+    set(KF5_MIN_VERSION "5.101.0")
     set(QT_MIN_VERSION "5.15.2")
     set(KDE_COMPILERSETTINGS_LEVEL "5.84.0")
 endif()
@@ -66,7 +66,7 @@
     set(Qca_LIBRARY qca-qt${QT_MAJOR_VERSION})
 
     set(KF5_REQUIRED_COMPONENTS I18n ConfigWidgets DBusAddons IconThemes Notifications KIO KCMUtils Service Solid Kirigami2 People WindowSystem GuiAddons)
-    set(KF5_OPTIONAL_COMPONENTS DocTools Wayland)
+    set(KF5_OPTIONAL_COMPONENTS DocTools)
 
     set_package_properties(KF5Kirigami2 PROPERTIES
         DESCRIPTION "QtQuick plugins to build user interfaces based on KDE UX guidelines"
@@ -83,7 +83,9 @@
         endif()
         find_package(Wayland 1.9 REQUIRED Client)
         find_package(Qt${QT_MAJOR_VERSION} REQUIRED COMPONENTS WaylandClient)
-        find_package(PlasmaWaylandProtocols REQUIRED)
+        find_package(WaylandProtocols REQUIRED)
+        pkg_check_modules(XkbCommon IMPORTED_TARGET xkbcommon)
+        pkg_check_modules(GIO REQUIRED IMPORTED_TARGET gio-2.0)
     endif()
 
     find_package(KF5PeopleVCard)
@@ -118,10 +120,6 @@
     string(REGEX MATCH "PlatformIdentity[^\n]*" PLATFORM_IDENTITY "${SDK_MANIFEST}" )
     string(REGEX MATCH "[0-9][0-9][0-9][0-9][0-9]" WIN_SDK_VERSION "${PLATFORM_IDENTITY}" )
     add_compile_definitions(WIN_SDK_VERSION=${WIN_SDK_VERSION})
-endif()
-
-if (NOT ZSH_AUTOCOMPLETE_DIR)
-set(ZSH_AUTOCOMPLETE_DIR "${KDE_INSTALL_DATADIR}/zsh/site-functions")
 endif()
 
 add_subdirectory(core)

=== app/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,11 @@
 qt5_add_resources(kdeconnect_SRCS resources.qrc)
 
 qt5_add_resources(kdeconnect_custom_icons_SRCS ${CMAKE_SOURCE_DIR}/icons/custom_icons.qrc)
+
+ecm_setup_version(${PROJECT_VERSION}
+    VARIABLE_PREFIX KDE_CONNECT
+    VERSION_HEADER ${CMAKE_CURRENT_BINARY_DIR}/kdeconnect-version.h
+)
 
 if (WIN32)
     include(ECMAddAppIcon)
@@ -17,6 +22,8 @@
     )
 endif()
 
+ecm_find_qmlmodule(org.kde.kirigamiaddons.labs.mobileform 0.1)
+
 add_executable(kdeconnect-app
     main.cpp
     ${kdeconnect_SRCS}

=== cli/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdeconnect-cli\")

add_executable(kdeconnect-cli kdeconnect-cli.cpp)
ecm_mark_nongui_executable(kdeconnect-cli)

target_link_libraries(kdeconnect-cli
    kdeconnectinterfaces
    kdeconnectcore
    kdeconnectversion
    KF5::CoreAddons
    KF5::I18n
)

install(TARGETS kdeconnect-cli ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

if (NOT SAILFISHOS)
    install(FILES kdeconnect.zsh RENAME _kdeconnect DESTINATION ${KDE_INSTALL_ZSHAUTOCOMPLETEDIR})
endif()

=== core/CMakeLists.txt ===
--- 
+++ 
@@ -32,7 +32,6 @@
     backends/linkprovider.cpp
     backends/devicelink.cpp
     backends/pairinghandler.cpp
-    backends/devicelinereader.cpp
 
     kdeconnectplugin.cpp
     kdeconnectpluginconfig.cpp
@@ -66,6 +65,10 @@
     KF5::ConfigCore
 )
 
+if(WIN32)
+    target_link_libraries(kdeconnectcore PRIVATE ws2_32.lib) # winsock2
+endif()
+
 if(${KF5KIO_FOUND})
     target_link_libraries(kdeconnectcore PUBLIC KF5::KIOCore KF5::KIOGui)
 endif()

=== data/CMakeLists.txt ===
install (FILES "kdeconnect.contract" DESTINATION ${KDE_INSTALL_DATADIR}/contractor/)
install (FILES "kdeconnect-thunar.desktop" DESTINATION ${KDE_INSTALL_DATADIR}/Thunar/sendto/)
install (FILES "kdeconnect-dde.desktop" DESTINATION ${KDE_INSTALL_DATADIR}/deepin/dde-file-manager/oem-menuextensions/)

if(NOT SAILFISHOS)
    install(FILES org.kde.kdeconnect.metainfo.xml DESTINATION ${KDE_INSTALL_METAINFODIR})
endif()

=== declarativeplugin/CMakeLists.txt ===
ecm_add_qml_module(kdeconnectdeclarativeplugin URI "org.kde.kdeconnect" VERSION 1.0)

target_sources(kdeconnectdeclarativeplugin PRIVATE
    kdeconnectdeclarativeplugin.cpp
    responsewaiter.cpp
    objectfactory.cpp
    pointerlocker.cpp
)

ecm_target_qml_sources(kdeconnectdeclarativeplugin
    SOURCES
    qml/DBusProperty.qml
    qml/PluginChecker.qml
    qml/RemoteKeyboard.qml
    VERSION 1.0)

if(UNIX AND NOT APPLE)

    if (QT_MAJOR_VERSION EQUAL "5")
        ecm_add_qtwayland_client_protocol(wayland_SRCS
            PROTOCOL ${WaylandProtocols_DATADIR}/unstable/pointer-constraints/pointer-constraints-unstable-v1.xml
            BASENAME pointer-constraints-unstable-v1
        )
        ecm_add_qtwayland_client_protocol(wayland_SRCS
            PROTOCOL ${WaylandProtocols_DATADIR}/unstable/relative-pointer/relative-pointer-unstable-v1.xml
            BASENAME relative-pointer-unstable-v1
        )
    else()
        qt6_generate_wayland_protocol_client_sources(kdeconnectdeclarativeplugin FILES
            ${WaylandProtocols_DATADIR}/unstable/pointer-constraints/pointer-constraints-unstable-v1.xml)
        qt6_generate_wayland_protocol_client_sources(kdeconnectdeclarativeplugin FILES
            ${WaylandProtocols_DATADIR}/unstable/relative-pointer/relative-pointer-unstable-v1.xml)
    endif()

    target_sources(kdeconnectdeclarativeplugin PRIVATE ${wayland_SRCS})
    target_link_libraries(kdeconnectdeclarativeplugin PRIVATE Wayland::Client Qt::WaylandClient Qt::GuiPrivate)
    target_sources(kdeconnectdeclarativeplugin PUBLIC pointerlockerwayland.cpp)
    target_compile_definitions(kdeconnectdeclarativeplugin PRIVATE -DWITH_WAYLAND=1)
endif()

target_link_libraries(kdeconnectdeclarativeplugin PRIVATE Qt::Quick kdeconnectinterfaces kdeconnectcore)

ecm_finalize_qml_module(kdeconnectdeclarativeplugin DESTINATION ${KDE_INSTALL_QMLDIR})

=== indicator/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdeconnect-indicator\")

set(debug_file_SRCS)
ecm_qt_declare_logging_category(
    debug_file_SRCS HEADER indicator_debug.h
    IDENTIFIER KDECONNECT_INDICATOR CATEGORY_NAME kdeconnect.indicator
    DEFAULT_SEVERITY Warning
    EXPORT kdeconnect-kde DESCRIPTION "kdeconnect (indicator)")

qt5_add_resources(kdeconnect_custom_icons_SRCS ${CMAKE_SOURCE_DIR}/icons/custom_icons.qrc)

set(indicator_SRCS
    main.cpp
    deviceindicator.cpp
    ${kdeconnect_custom_icons_SRCS}
    ${CMAKE_CURRENT_SOURCE_DIR}/systray_actions/battery_action.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/systray_actions/connectivity_action.cpp
)

include(ECMAddAppIcon)

ecm_add_app_icon(indicator_SRCS ICONS
    ${CMAKE_SOURCE_DIR}/icons/app/sc-apps-kdeconnect.svg
    ${CMAKE_SOURCE_DIR}/icons/app/16-apps-kdeconnect.png
    ${CMAKE_SOURCE_DIR}/icons/app/24-apps-kdeconnect.png
    ${CMAKE_SOURCE_DIR}/icons/app/32-apps-kdeconnect.png
    ${CMAKE_SOURCE_DIR}/icons/app/48-apps-kdeconnect.png
    ${CMAKE_SOURCE_DIR}/icons/app/64-apps-kdeconnect.png
    ${CMAKE_SOURCE_DIR}/icons/app/128-apps-kdeconnect.png
    ${CMAKE_SOURCE_DIR}/icons/app/256-apps-kdeconnect.png
    ${CMAKE_SOURCE_DIR}/icons/app/1024-apps-kdeconnect.png
)

if (WIN32)
    list(APPEND indicator_SRCS indicatorhelper_win.cpp)
elseif (APPLE)
    list(APPEND indicator_SRCS indicatorhelper_mac.cpp serviceregister_mac.mm)
else ()
    list(APPEND indicator_SRCS indicatorhelper.cpp)
endif()

add_executable(kdeconnect-indicator ${indicator_SRCS} ${debug_file_SRCS})

target_include_directories(kdeconnect-indicator PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/systray_actions)

target_link_libraries(kdeconnect-indicator Qt::Widgets KF5::CoreAddons KF5::I18n KF5::Notifications KF5::DBusAddons KF5::KCMUtils kdeconnectinterfaces kdeconnectcore kdeconnectversion)

if (WIN32)
    target_link_libraries(kdeconnect-indicator windowsapp)
    target_compile_features(kdeconnect-indicator PUBLIC cxx_std_17)
endif()

if (APPLE)
# Apple frameworks
target_link_libraries(kdeconnect-indicator "-framework AppKit")
# Apple app package
set_target_properties(kdeconnect-indicator PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/Info.plist)
set_target_properties(kdeconnect-indicator PROPERTIES
    MACOSX_BUNDLE_BUNDLE_NAME "KDE Connect"
    MACOSX_BUNDLE_LONG_VERSION_STRING "${KDECONNECT_VERSION_STRING}"
    MACOSX_BUNDLE_SHORT_VERSION_STRING "${KDECONNECT_VERSION_MAJOR}.${KDECONNECT_VERSION_MINOR}.${KDECONNECT_VERSION_PATCH}"
    MACOSX_BUNDLE_GUI_IDENTIFIER "org.kde.kdeconnect")
endif()

install(TARGETS kdeconnect-indicator ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
install(PROGRAMS org.kde.kdeconnect.nonplasma.desktop DESTINATION ${KDE_INSTALL_APPDIR})

=== interfaces/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdeconnect-interfaces\")

function(geninterface source_h output_h)
    set(xml_file ${CMAKE_CURRENT_BINARY_DIR}/${output_h}.xml)
    qt_generate_dbus_interface( ${source_h} ${xml_file})

    set_source_files_properties(${xml_file} PROPERTIES NO_NAMESPACE true)

    qt_add_dbus_interface(libkdeconnect_SRC ${xml_file} ${output_h})
    set(libkdeconnect_SRC ${libkdeconnect_SRC} PARENT_SCOPE)
endfunction()

set(debug_files_SRCS)
ecm_qt_declare_logging_category(
    debug_files_SRCS HEADER interfaces_conversation_message_debug.h
    IDENTIFIER CONVERSATION_MESSAGE_LOGGING_CATEGORY CATEGORY_NAME kdeconnect.interfaces.conversationmessage
    DEFAULT_SEVERITY Warning
    EXPORT kdeconnect-kde DESCRIPTION "kdeconnect (conversation message)")

ecm_qt_declare_logging_category(
    debug_files_SRCS HEADER interfaces_debug.h
    IDENTIFIER KDECONNECT_INTERFACES CATEGORY_NAME kdeconnect.interfaces
    DEFAULT_SEVERITY Warning
    EXPORT kdeconnect-kde DESCRIPTION "kdeconnect (interfaces)")

set(libkdeconnect_SRC
    dbusinterfaces.cpp
    devicesmodel.cpp
    notificationsmodel.cpp
    devicessortproxymodel.cpp
    conversationmessage.cpp
    remotecommandsmodel.cpp
    remotesinksmodel.cpp
    devicespluginfilterproxymodel.cpp
    pluginmodel.cpp
    commandsmodel.cpp
#    modeltest.cpp
    ${debug_files_SRCS}
)

geninterface(${PROJECT_SOURCE_DIR}/core/daemon.h daemoninterface)
geninterface(${PROJECT_SOURCE_DIR}/core/device.h deviceinterface)
geninterface(${PROJECT_SOURCE_DIR}/plugins/battery/batteryplugin.h batteryinterface)
geninterface(${PROJECT_SOURCE_DIR}/plugins/connectivity-report/connectivity_reportplugin.h connectivityinterface)
geninterface(${PROJECT_SOURCE_DIR}/plugins/sftp/sftpplugin.h devicesftpinterface)
geninterface(${PROJECT_SOURCE_DIR}/plugins/notifications/notificationsplugin.h devicenotificationsinterface)
geninterface(${PROJECT_SOURCE_DIR}/plugins/findmyphone/findmyphoneplugin.h devicefindmyphoneinterface)
geninterface(${PROJECT_SOURCE_DIR}/plugins/notifications/notification.h notificationinterface)
geninterface(${PROJECT_SOURCE_DIR}/plugins/mprisremote/mprisremoteplugin.h mprisremoteinterface)
geninterface(${PROJECT_SOURCE_DIR}/plugins/remotecontrol/remotecontrolplugin.h remotecontrolinterface)
geninterface(${PROJECT_SOURCE_DIR}/plugins/lockdevice/lockdeviceplugin.h lockdeviceinterface)
geninterface(${PROJECT_SOURCE_DIR}/plugins/remotecommands/remotecommandsplugin.h remotecommandsinterface)
geninterface(${PROJECT_SOURCE_DIR}/plugins/remotekeyboard/remotekeyboardplugin.h remotekeyboardinterface)
geninterface(${PROJECT_SOURCE_DIR}/plugins/sms/smsplugin.h smsinterface)
geninterface(${PROJECT_SOURCE_DIR}/plugins/sms/conversationsdbusinterface.h conversationsinterface)
geninterface(${PROJECT_SOURCE_DIR}/plugins/share/shareplugin.h shareinterface)
geninterface(${PROJECT_SOURCE_DIR}/plugins/remotesystemvolume/remotesystemvolumeplugin.h remotesystemvolumeinterface)
geninterface(${PROJECT_SOURCE_DIR}/plugins/bigscreen/bigscreenplugin.h bigscreeninterface)
geninterface(${PROJECT_SOURCE_DIR}/plugins/virtualmonitor/virtualmonitorplugin.h virtualmonitorinterface)
geninterface(${PROJECT_SOURCE_DIR}/plugins/photo/photoplugin.h photointerface)
geninterface(${PROJECT_SOURCE_DIR}/plugins/clipboard/clipboardplugin.h deviceclipboardinterface)

add_library(kdeconnectinterfaces ${libkdeconnect_SRC})
set_target_properties(kdeconnectinterfaces PROPERTIES
    VERSION ${KDECONNECT_VERSION}
    SOVERSION ${KDECONNECT_VERSION_MAJOR}
)

generate_export_header(kdeconnectinterfaces EXPORT_FILE_NAME ${CMAKE_CURRENT_BINARY_DIR}/kdeconnectinterfaces_export.h BASE_NAME KDEConnectInterfaces)

target_link_libraries(kdeconnectinterfaces
LINK_PUBLIC
    Qt${QT_MAJOR_VERSION}::Gui
    Qt${QT_MAJOR_VERSION}::DBus
    KF5::ConfigCore
LINK_PRIVATE
    kdeconnectcore
    KF5::I18n
    kdeconnectcore
    KF5::CoreAddons
)

install(TARGETS kdeconnectinterfaces EXPORT kdeconnectLibraryTargets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} LIBRARY NAMELINK_SKIP)

=== kcm/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN="kdeconnect-kcm")


kcoreaddons_add_plugin(kcm_kdeconnect SOURCES kcm.cpp INSTALL_NAMESPACE plasma/kcms/systemsettings_qwidgets)
kcmutils_generate_desktop_file(kcm_kdeconnect)

ki18n_wrap_ui(kcm_kdeconnect kcm.ui)

target_link_libraries(kcm_kdeconnect
    Qt::Core
    Qt::Gui
    KF5::I18n
    KF5::KCMUtils
    kdeconnectinterfaces
    kdeconnectversion
)

=== kcmplugin/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdeconnect-core\")

add_library(kdeconnectpluginkcm kdeconnectpluginkcm.cpp)
target_link_libraries(kdeconnectpluginkcm
PUBLIC
    kdeconnectcore
PRIVATE
    Qt::DBus
    Qt::Gui
    KF5::I18n
    KF5::ConfigCore
    KF5::KCMUtils
)

set_target_properties(kdeconnectpluginkcm PROPERTIES
    VERSION ${KDECONNECT_VERSION}
    SOVERSION ${KDECONNECT_VERSION_MAJOR}
)

generate_export_header(kdeconnectpluginkcm EXPORT_FILE_NAME kdeconnectpluginkcm_export.h BASE_NAME kdeconnectpluginkcm)

# Remove NAMELINK_SKIP if/when headers are being installed and the library becomes public.
install(TARGETS kdeconnectpluginkcm EXPORT kdeconnectLibraryTargets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} LIBRARY NAMELINK_SKIP)

=== kio/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN="kdeconnect-kio")

set(debug_file_SRCS)
ecm_qt_declare_logging_category(
    debug_file_SRCS HEADER kdeconnectkio_debug.h
    IDENTIFIER KDECONNECT_KIO CATEGORY_NAME kdeconnect.kio
    DEFAULT_SEVERITY Warning
    EXPORT kdeconnect-kde DESCRIPTION "kdeconnect (kio)")

set(kio_kdeconnect_PART_SRCS
   kiokdeconnect.cpp
   ${debug_file_SRCS}
)

add_library(kio_kdeconnect MODULE ${kio_kdeconnect_PART_SRCS})

target_link_libraries(kio_kdeconnect
    kdeconnectinterfaces
    Qt::Core
    Qt::Network
    KF5::KIOCore
    KF5::I18n
)

########### install files ###############
set_target_properties(kio_kdeconnect PROPERTIES OUTPUT_NAME "kdeconnect")
set_target_properties(kio_kdeconnect PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/kf5/kio")
install(TARGETS kio_kdeconnect DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf5/kio)

=== plugins/CMakeLists.txt ===
--- 
+++ 
@@ -38,7 +38,14 @@
     add_subdirectory(screensaver-inhibit)
     add_subdirectory(virtualmonitor)
 
-    if(NOT WIN32)
+    if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
+        find_package(KF5ModemManagerQt ${KF5_MIN_VERSION})
+        if (TARGET KF5::ModemManagerQt)
+            add_subdirectory(mmtelephony)
+        endif()
+    endif()
+
+    if(NOT WIN32 AND NOT APPLE)
         add_subdirectory(sendnotifications)
     endif()

=== debian/changelog ===
kdeconnect (23.08.5-0ubuntu5) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 09:03:08 +0000

kdeconnect (23.08.5-0ubuntu4) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 04:50:03 +0000

kdeconnect (23.08.5-0ubuntu3) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 11 Mar 2024 22:54:28 +0000

kdeconnect (23.08.5-0ubuntu2) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 05:13:57 +0000

kdeconnect (23.08.5-0ubuntu1) noble; urgency=medium

  * New upstream release (23.08.5)

 -- Scarlett Moore <sgmoore@debian.org>  Thu, 22 Feb 2024 09:41:27 -0700

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: kdeconnect
 Section: kde
 Priority: optional
-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Aurélien COUDERC <coucouf@debian.org>,
+           Norbert Preining <norbert@preining.info>,
 Build-Depends: cmake (>= 3.0~),
                debhelper-compat (= 13),
-               dh-sequence-kf5,
                extra-cmake-modules (>= 5.96.0~),
                gettext,
                kirigami2-dev (>= 5.96.0~),
@@ -34,7 +35,9 @@
                libwayland-dev (>= 1.9~),
                libx11-dev,
                libxtst-dev,
+               modemmanager-qt-dev,
                pkg-config,
+               pkg-kde-tools,
                plasma-wayland-protocols,
                qtbase5-dev (>= 5.15.2~),
                qtbase5-private-dev (>= 5.10.0~),
@@ -42,11 +45,12 @@
                qtmultimedia5-dev (>= 5.15.2~),
                qtquickcontrols2-5-dev (>= 5.15.2~),
                qtwayland5-dev-tools,
-Standards-Version: 4.6.2
+               wayland-protocols,
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: https://kdeconnect.kde.org
-Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/kdeconnect.git
-Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/kdeconnect
+Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kdeconnect-kde
+Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kdeconnect-kde
 
 Package: kdeconnect
 Architecture: any
@@ -55,6 +59,7 @@
          libqca-qt5-2-plugins,
          plasma-framework,
          qml-module-org-kde-kirigami2,
+         qml-module-org-kde-kirigami-addons-labs-mobileform,
          qml-module-org-kde-kquickcontrolsaddons,
          qml-module-org-kde-people,
          qml-module-qt-labs-platform,
@@ -70,7 +75,7 @@
          sshfs (>= 3),
          ${misc:Depends},
          ${shlibs:Depends},
-Breaks: fuse (<< 3),
+Breaks: fuse (<< 3)
 Description: connect smartphones to your desktop devices
  Tool to integrate your smartphone, tablet, and desktop devices.
  Remote-control, share files, synchronize notifications, and more!
@@ -79,10 +84,10 @@
 
 Package: nautilus-kdeconnect
 Architecture: all
-Depends: kdeconnect, nautilus, python3-nautilus, ${misc:Depends},
-Enhances: nautilus,
-Breaks: kdeconnect (<< 20.12),
-Replaces: kdeconnect (<< 20.12),
+Depends: kdeconnect, nautilus, python3-nautilus, ${misc:Depends}
+Enhances: nautilus
+Breaks: kdeconnect (<< 20.12)
+Replaces: kdeconnect (<< 20.12)
 Description: KDE Connect integration for Nautilus
  Extension providing integration to send files to KDE Connect compatible
  devices directly from within Nautilus.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with=kf5

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DBUILD_TESTING=OFF

override_dh_auto_test:
	# Disable dh_auto_test at build time
	:

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.sig/ https://download.kde.org/stable/release-service/([\d.]+)/src/kdeconnect-kde-([\d.]+)\.tar\.xz
